import json
from typing import Dict, Any
import pytest
from chem_kit import Transformation

test_data = (
    (
        "[#8:1]-[#6:2]1:[#6:3](:[#6:5]:[#6:8]:[#6:7]:[#6:4]:1)-[#1:6]>>[#6:8]1:[#6:5]"
        ":[#6:3](-[#8:6]-[#1]):[#6:2](-[#8:1]):[#6:4]:[#6:7]:1",
        {
            "m": [
                {
                    "a": [
                        {
                            "i": "a0",
                            "x": 5.684341886080802e-14,
                            "y": -30.000000000000032,
                            "l": "O",
                        },
                        {"i": "a1", "x": 25.980762113533192, "y": -15.000000000000018},
                        {"i": "a2", "x": 25.98076211353319, "y": 15.000000000000007},
                        {"i": "a3", "x": 51.96152422706634, "y": 30.000000000000007},
                        {"i": "a4", "x": 77.94228634059951, "y": 15.000000000000018},
                        {"i": "a5", "x": 77.94228634059951, "y": -14.99999999999999},
                        {"i": "a6", "x": 51.96152422706636, "y": -30.000000000000004},
                        {"i": "a7", "x": 0.0, "y": 30.000000000000014, "l": "H"},
                    ],
                    "b": [
                        {"i": "b0", "b": 0, "e": 1},
                        {"i": "b1", "b": 1, "e": 2, "o": 2},
                        {"i": "b2", "b": 3, "e": 4, "o": 2},
                        {"i": "b3", "b": 4, "e": 5},
                        {"i": "b4", "b": 5, "e": 6, "o": 2},
                        {"i": "b5", "b": 2, "e": 3},
                        {"i": "b6", "b": 2, "e": 7},
                        {"i": "b7", "b": 6, "e": 1},
                    ],
                },
                {
                    "a": [
                        {"i": "a8", "x": 360.77326242058894, "y": -19.87158579839083},
                        {"i": "a9", "x": 332.8966556108412, "y": -30.957378182101188},
                        {"i": "a10", "x": 309.3577743805942, "y": -12.358424705404609},
                        {
                            "i": "a11",
                            "x": 281.48116757084654,
                            "y": -23.444217089114964,
                            "l": "O",
                        },
                        {
                            "i": "a12",
                            "x": 257.9422863405995,
                            "y": -4.84526361241838,
                            "l": "H",
                        },
                        {"i": "a13", "x": 313.6954999600948, "y": 17.32632115500231},
                        {
                            "i": "a14",
                            "x": 290.15661872984776,
                            "y": 35.925274631698876,
                            "l": "O",
                        },
                        {"i": "a15", "x": 341.57210676984243, "y": 28.412113538712667},
                        {"i": "a16", "x": 365.1109880000895, "y": 9.813160062016099},
                    ],
                    "b": [
                        {"i": "b8", "b": 0, "e": 1, "o": 2},
                        {"i": "b9", "b": 1, "e": 2},
                        {"i": "b10", "b": 3, "e": 4},
                        {"i": "b11", "b": 2, "e": 3},
                        {"i": "b12", "b": 2, "e": 5, "o": 2},
                        {"i": "b13", "b": 5, "e": 6},
                        {"i": "b14", "b": 5, "e": 7},
                        {"i": "b15", "b": 7, "e": 8, "o": 2},
                        {"i": "b16", "b": 8, "e": 0},
                    ],
                },
            ],
            "s": [
                {
                    "i": "s0",
                    "t": "Line",
                    "x1": 117.94228634059951,
                    "y1": 0.0,
                    "x2": 177.9422863405995,
                    "y2": 0.0,
                    "a": "synthetic",
                },
                {"i": "s1", "t": "AtomMapping", "a1": "a0", "a2": "a14"},
                {"i": "s2", "t": "AtomMapping", "a1": "a1", "a2": "a13"},
                {"i": "s3", "t": "AtomMapping", "a1": "a2", "a2": "a10"},
                {"i": "s5", "t": "AtomMapping", "a1": "a3", "a2": "a9"},
                {"i": "s8", "t": "AtomMapping", "a1": "a4", "a2": "a8"},
                {"i": "s7", "t": "AtomMapping", "a1": "a5", "a2": "a16"},
                {"i": "s4", "t": "AtomMapping", "a1": "a6", "a2": "a15"},
                {"i": "s6", "t": "AtomMapping", "a1": "a7", "a2": "a11"},
            ],
        },
    ),
    (
        "[#8:1](-[#6:2])-[#1:3]>>[#6:3](-[#8:1]-[#6:2])(-[#1])(-[#1])-[#1]",
        {
            "m": [
                {
                    "a": [
                        {
                            "i": "a0",
                            "x": 25.98076211353316,
                            "y": 10.000000000000002,
                            "l": "O",
                        },
                        {"i": "a1", "x": 0.0, "y": -4.999999999999994},
                        {
                            "i": "a2",
                            "x": 51.96152422706632,
                            "y": -5.000000000000007,
                            "l": "H",
                        },
                    ],
                    "b": [{"i": "b0", "b": 0, "e": 1}, {"i": "b1", "b": 0, "e": 2}],
                },
                {
                    "a": [
                        {"i": "a3", "x": 283.9230484541326, "y": -7.40148683083439e-16},
                        {
                            "i": "a4",
                            "x": 257.9422863405994,
                            "y": 15.000000000000009,
                            "l": "O",
                        },
                        {
                            "i": "a5",
                            "x": 231.9615242270663,
                            "y": 1.2582527612418439e-14,
                        },
                        {
                            "i": "a6",
                            "x": 309.9038105676658,
                            "y": -15.000000000000014,
                            "l": "H",
                        },
                        {
                            "i": "a7",
                            "x": 298.92304845413264,
                            "y": 25.98076211353316,
                            "l": "H",
                        },
                        {
                            "i": "a8",
                            "x": 268.9230484541326,
                            "y": -25.980762113533164,
                            "l": "H",
                        },
                    ],
                    "b": [
                        {"i": "b2", "b": 1, "e": 2},
                        {"i": "b3", "b": 0, "e": 1},
                        {"i": "b4", "b": 0, "e": 3},
                        {"i": "b5", "b": 0, "e": 4},
                        {"i": "b6", "b": 0, "e": 5},
                    ],
                },
            ],
            "s": [
                {
                    "i": "s0",
                    "t": "Line",
                    "x1": 91.96152422706632,
                    "y1": 0,
                    "x2": 151.96152422706632,
                    "y2": 0,
                    "a": "synthetic",
                },
                {"i": "s1", "t": "AtomMapping", "a1": "a0", "a2": "a4"},
                {"i": "s2", "t": "AtomMapping", "a1": "a1", "a2": "a5"},
                {"i": "s3", "t": "AtomMapping", "a1": "a2", "a2": "a3"},
            ],
        },
    ),
    (
        "[H:3][#7,#8,C:1]-[*:2]>>[H][#6+:3]([H])-[#7,#8]-[#6:2]",
        {
            "m": [
                {
                    "a": [
                        {
                            "i": "a0",
                            "x": 51.96152422706632,
                            "y": -5.000000000000007,
                            "l": "H",
                        },
                        {
                            "i": "a1",
                            "x": 25.98076211353316,
                            "y": 10.000000000000002,
                            "q": {"as": {"v": ["N", "O", "C"], "n": False}},
                        },
                        {
                            "i": "a2",
                            "x": 0.0,
                            "y": -4.999999999999994,
                            "q": {"as": {"v": ["a"], "n": False}},
                        },
                    ],
                    "b": [{"i": "b0", "b": 0, "e": 1}, {"i": "b1", "b": 1, "e": 2}],
                },
                {
                    "a": [
                        {
                            "i": "a3",
                            "x": 231.96152422706632,
                            "y": -14.999999999999991,
                            "l": "H",
                        },
                        {
                            "i": "a4",
                            "x": 257.9422863405995,
                            "y": 4.440892098500626e-15,
                            "c": 1,
                        },
                        {
                            "i": "a5",
                            "x": 257.9422863405995,
                            "y": 29.999999999999996,
                            "l": "H",
                        },
                        {
                            "i": "a6",
                            "x": 283.92304845413264,
                            "y": -15.000000000000004,
                            "q": {"as": {"v": ["N", "O"], "n": False}},
                        },
                        {
                            "i": "a7",
                            "x": 309.9038105676658,
                            "y": -8.881784197001252e-15,
                        },
                    ],
                    "b": [
                        {"i": "b2", "b": 0, "e": 1},
                        {"i": "b3", "b": 2, "e": 1},
                        {"i": "b4", "b": 1, "e": 3},
                        {"i": "b5", "b": 3, "e": 4},
                    ],
                },
            ],
            "s": [
                {
                    "i": "s0",
                    "t": "Line",
                    "x1": 91.96152422706632,
                    "y1": 0.0,
                    "x2": 151.96152422706632,
                    "y2": 0.0,
                    "a": "synthetic",
                },
                {"i": "s3", "t": "AtomMapping", "a1": "a0", "a2": "a4"},
                {"i": "s1", "t": "AtomMapping", "a1": "a1", "a2": None},
                {"i": "s2", "t": "AtomMapping", "a1": "a2", "a2": "a7"},
            ],
        },
    ),
    (
        "[#6][C@@]([#7])([#8])[#16]>>[#6]-[#8][C@@]([#6])([#7])[#16]",
        {
            "m": [
                {
                    "a": [
                        {"i": "a0", "x": 0.0, "y": -14.999999999999998},
                        {
                            "i": "a1",
                            "x": 25.98076211353316,
                            "y": -2.220446049250313e-15,
                        },
                        {
                            "i": "a2",
                            "x": 51.96152422706632,
                            "y": 14.999999999999998,
                            "l": "N",
                        },
                        {
                            "i": "a3",
                            "x": 40.98076211353316,
                            "y": -25.980762113533167,
                            "l": "O",
                        },
                        {
                            "i": "a4",
                            "x": 10.98076211353316,
                            "y": 25.98076211353316,
                            "l": "S",
                        },
                    ],
                    "b": [
                        {"i": "b0", "b": 0, "e": 1, "s": "recessed"},
                        {"i": "b1", "b": 2, "e": 1},
                        {"i": "b2", "b": 3, "e": 1, "s": "protruding"},
                        {"i": "b3", "b": 1, "e": 4},
                    ],
                },
                {
                    "a": [
                        {
                            "i": "a5",
                            "x": 231.9615242270663,
                            "y": 1.2582527612418439e-14,
                        },
                        {
                            "i": "a6",
                            "x": 257.9422863405994,
                            "y": 15.000000000000009,
                            "l": "O",
                        },
                        {"i": "a7", "x": 283.9230484541326, "y": -7.40148683083439e-16},
                        {"i": "a8", "x": 268.9230484541326, "y": -25.980762113533164},
                        {
                            "i": "a9",
                            "x": 298.92304845413264,
                            "y": 25.98076211353316,
                            "l": "N",
                        },
                        {
                            "i": "a10",
                            "x": 309.9038105676658,
                            "y": -15.000000000000014,
                            "l": "S",
                        },
                    ],
                    "b": [
                        {"i": "b4", "b": 0, "e": 1},
                        {"i": "b5", "b": 1, "e": 2, "s": "recessed"},
                        {"i": "b6", "b": 3, "e": 2},
                        {"i": "b7", "b": 4, "e": 2, "s": "protruding"},
                        {"i": "b8", "b": 2, "e": 5},
                    ],
                },
            ],
            "s": [
                {
                    "i": "s0",
                    "t": "Line",
                    "x1": 91.96152422706632,
                    "y1": 0.0,
                    "x2": 151.96152422706632,
                    "y2": 0.0,
                    "a": "synthetic",
                }
            ],
        },
    ),
)


@pytest.mark.parametrize("smarts,expected_result", test_data)
def test_transformation(smarts: str, expected_result: Dict[str, Any]) -> None:

    tsf = Transformation(smarts)
    result = tsf.get_chemdoodle_json()
    print(result)
    print(json.dumps(result))
    assert result == expected_result
    # assert False
